﻿using System;
using System.Windows;
using System.IO;
using System.Windows.Threading;
using System.Reflection;


namespace Contracts
{

    // ЖЖжесть. В .нете есть миксины! (ну почти, они только переопределять не умеют) http://msdn.microsoft.com/ru-ru/library/bb383977.aspx

    /// <summary>
    /// Contains extension methods for this namespace.
    /// </summary>
    public static class ExtensionMethods
    {

        private static readonly Action EmptyDelegate = delegate() { };

        // via http://geekswithblogs.net/NewThingsILearned/archive/2008/08/25/refresh--update-wpf-controls.aspx
        public static void Refresh(this UIElement uiElement)
        {
            uiElement.Dispatcher.Invoke(DispatcherPriority.Render, EmptyDelegate); // not works in windows 7
            //uiElement.Dispatcher.Invoke(DispatcherPriority.ContextIdle, EmptyDelegate);
        }

    // Нам надо расширить StreamReader
    // Чтобы вытаскивать из него текущую позицию. Это надо для чтения массовых операций из файлов из Руби
    // Источник: http://www.daniweb.com/software-development/csharp/threads/35078/page2

        /// <summary>
        /// Gets the current read position of the StreamReader.
        /// </summary>
        /// <param name="streamReader">The StreamReader object to get the position for.</param>
        /// <returns>Current read position in the StreamReader.</returns>
        public static long GetPosition(this StreamReader streamReader)
        {
            // Based on code shared on www.daniweb.com by user mfm24(Matt).
            int charpos = (int)streamReader.GetType().InvokeMember(
                "charPos",
                BindingFlags.DeclaredOnly | BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Instance | BindingFlags.GetField,
                null,
                streamReader,
                null);
            int charlen = (int)streamReader.GetType().InvokeMember(
                "charLen",
                BindingFlags.DeclaredOnly | BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Instance | BindingFlags.GetField,
                null,
                streamReader,
                null);
            return streamReader.BaseStream.Position - charlen + charpos;
        }

        /// <summary>
        /// Sets the current read position of the StreamReader.
        /// </summary>
        /// <param name="streamReader">The StreamReader object to get the position for.</param>
        /// <param name="position">The position to move to in the file, starting from the beginning.</param>
        public static void SetPosition(this StreamReader streamReader, long position)
        {
            streamReader.BaseStream.Seek(position, SeekOrigin.Begin);
            streamReader.DiscardBufferedData();
        }
    }


}