﻿namespace Contracts
{
    /// <summary>
    /// Интерфейс для классов свойств, значения которых для группы 
    /// объектов вычисляется по особой формуле
    /// </summary>
    public interface IAbleToGroup
    {
        /// <summary>
        /// Метод, вызываемый при группировке свойств нескольких объектов.
        /// Данный метод вызывается последовательно у свойства каждого
        /// объекта, передавая в качестве параметра накопленный результат
        /// </summary>
        /// <param name="another">накопленное значение свойства без текущего объекта</param>
        /// <returns>значение свойства после добавления в коллекцию текущего объекта</returns>
        IAbleToGroup GroupWith(IAbleToGroup another);
    }
}
