using System.Windows.Media.Media3D;

namespace Contracts
{
    public delegate void ScaleChanged(Vector3D scale);
    public interface ICameraWithMetaData:IObjectWithMetaData
    {
        event ScaleChanged OnScaleChanged; 
        ProjectionCamera Camera { get; set; }
        double X { get; set; }
        double Y { get; set; }
        double Z { get; set; }
        Transform3D Transform { get; set; }
        bool RotationEnabled { get; }
        bool ZoomEnabled { get; }
        bool MoveInPerpendicularPlaneEnabled { get; }
        bool MoveInParallelPlaneEnabled { get; }
        bool Selected { get; set; }
        Vector3D Scale { get; set; }
    }
}