﻿using System;

namespace Contracts
{
    /// <summary>
    /// Интерфейс доступа к свойству модели
    /// </summary>
    public interface IModelPropertyAccessor
    {
        /// <summary>
        /// Метод, устанавливающий в свойство модели propertyName значение value
        /// </summary>
        /// <param name="propertyName">Свойство модели</param>
        /// <param name="value">Устанавливаемое значение</param>
        void SetProperty(String propertyName, object value);
        /// <summary>
        /// Метод, возвращающий значение свойства модели
        /// </summary>
        /// <param name="propertyName">Свойство Модели</param>
        /// <returns>Значение</returns>
        object GetProperty(String propertyName);
    }
}
