﻿using System;
using System.Windows;

namespace Contracts
{
    public abstract class IUIControl
    {
        private object _value;
        private IModelPropertyAccessor _modelPropertyAccessor;
        private string _propertyName;
        public abstract Type ControlledType {get;}
        public abstract FrameworkElement Control { get; }
        public object Value 
        { 
            set
            {
                if (value != _value)
                {
                    _value = value;
                    if (_modelPropertyAccessor != null)
                        _modelPropertyAccessor.SetProperty(_propertyName, value);
                }

            }
           get
           {
               return _value;   
           }
        }
       public void SetModelPropertyAccessor(IModelPropertyAccessor modelPropertyAccessor,String propertyName)
        {
           _modelPropertyAccessor = modelPropertyAccessor;
           _value = modelPropertyAccessor.GetProperty(propertyName);
           _propertyName = propertyName;
        }

    }

    
}
