# make sharpeye vars accessible both in local and global manners

$logger = logger
$engine = engine
$scene = scene
$sharpeye_root = sharpeye_root
$importer = importer
$exporter = exporter

#  alias :scene    :$scene
#  alias :logger   :$logger
#  alias :engine   :$engine
#  alias :sharpeye_root :$sharpeye_root
#  alias :importer :$importer
#  alias :exporter :$exporter
#
#module SharpEyeCommon
#
##$logger = logger
##$engine = engine
##$scene = scene
##$sharpeye_root = sharpeye_root
##$importer = importer
##$exporter = exporter
#
#
##  def logger; $logger; end
##  def engine; $engine; end
##
##  $sharpeye_root = sharpeye_root
##  $importer = importer
##  $exporter = exporter
##
#
#end
#
#include SharpEyeCommon

load_assembly 'PresentationCore' 
load_assembly 'PresentationFramework' 

include System::Windows::Media::Media3D #for Point3D
include System
include System::Windows::Input
# include Visualizator

def puts(msg)
#  Visualizator::Logger.Info( msg )
#  @logger ||= logger_var.class
#  defined?(logger) ? logger.info(msg) : super
#  logger.info(msg) rescue puts(msg)
  logger.info(msg.to_s)
end

def progress(percent)
#  Visualizator::Logger.Info( msg )
#  @logger ||= logger_var.class
  logger.progress percent
end

def add_model(name,desc="",visible=true,parent_group=nil)
  m = scene.add_model(name,desc,visible,parent_group)
  @models_list ||= []
  @models_list << m
  @current_model = m
  create_default_model_methods if @current_model_methods_created != true
  m
end

def created_models
  @models_list || []  
end

def reset_created_models
  @models_list = nil
  @current_model = nil
end

def finalize_models
  created_models.each{ |m| 
    #m.finalize_construction
    m.refresh
  }
end

#def register_filter
#  puts "Invoked register_filter on #{self}"
#end
#
#class Filter
#  def self.register_filter
#    puts self
#  end
#end

#module Filter
#  def self.included(base)
#    STDOUT.puts base
#  end
#end

#class Bla 
#  include Filter
#end

# class Bla < Filter
#  register_filter
#  
# end

# hehe, we undef standard load method
#undef load


## Default models methods
# Это для того, чтобы можно было говорит add_triangle например, а не m.add_triangle

# from http://blog.jayfields.com/2008/02/ruby-replace-methodmissing-with-dynamic.html
def create_default_model_methods
  logger.info "Invoked create_default_model_methods ##start"
  @current_model.public_methods(false).each do |meth|
      (class << self; self; end).class_eval do
        define_method meth do |*args|
          @current_model.send meth, *args
        end
      end
    end
  logger.info "Invoked create_default_model_methods ##done"
  @current_model_methods_created = true
end


#def method_missing(meth, *args, &block)
#  super
#end

#def method_missing(meth, *args, &block)
#  if @current_model and @current_model.respond_to(meth)
#self.class.class_eval <<-end_eval
#  def #{meth}(*args, &block)
#    @current_model.__send__(:#{meth}, *args, &block)
#  end
#end_eval
#__send__(meth, *args, &block)
#  else
#    super 
#  end
#end

# subclasses method from http://www.ruby-forum.com/topic/163430
   class Class
     def inherited other
       super if defined? super
     ensure
       ( @subclasses ||= [] ).push(other).uniq!
     end

     def subclasses
       @subclasses ||= []
       @subclasses.inject( [] ) do |list, subclass|
         list.push(subclass, *subclass.subclasses)
       end
     end
   end


class SharpEyeKa

  # Acceess to SharpEye api
  def logger; $logger; end
  def engine; $engine; end
  def scene; $scene; end
  def sharpeye_root; $sharpeye_root; end
  def importer; $importer; end
  def exporter; $exporter; end

  def self.logger; $logger; end
  def self.engine; $engine; end
  def self.scene; $scene; end
  def self.sharpeye_root; $sharpeye_root; end
  def self.importer; $importer; end
  def self.exporter; $exporter; end

end

class Loader < SharpEyeKa

  #   feel(p) is invoked to determine - can this file load data or not?
  #
  #   p.ext // file extension in lower case, e.g. "dat"
  #   p.first_2k // first 2048 bytes of file data.
  #   p.first_lines // ascii presentation of first2k. If file contains \0, firstlines is cutted to that first \0.
  #   p.name // file name without extension
  #   p.path // full file path

  def self.feel(p)
    puts "WARNING: called feel of Loader class. This means that some of your loader class has not specified it's feel method."
    puts self.class
    puts caller[0..3].join("\n")
    0
  end

  def load(p)
    puts "WARNING: called load of Loader class. This means that some of your loader class has not specified it's load method."
    puts self.class
    puts caller[0..3].join("\n")
  end

  def add_checkbox( model,title,checked=1 )
    c = System::Windows::Controls::CheckBox.new  
    c.is_checked = checked ? true : false
    c.checked do |sender, args|
      yield true
    end
    c.unchecked do |sender, args|
      yield false
    end    

    model.add_ui_element(c,title)
    c
  end

  # http://msdn.microsoft.com/ru-ru/library/system.windows.controls.slider.aspx
  # to add valid tooltips: http://wpfdude.blogspot.ru/2010/07/rule-of-thumb-sliders-thumb.html
  def add_slider( model,title,min,max,value=1 )
    slider = System::Windows::Controls::Slider.new
    slider.minimum = min
    slider.maximum = max
    slider.value = value
    slider.IsSnapToTickEnabled = true
    slider.TickFrequency = 1
    slider.TickPlacement = TickPlacement.Both
    slider.AutoToolTipPlacement = AutoToolTipPlacement.BottomRight

#    slider.value_changed do |sender, args|
    slider.PreviewMouseUp do |sender, args|
       yield slider.value.to_i
    end

    slider.KeyUp do |sender, args|
       yield slider.value.to_i
    end
    
    model.add_ui_element(slider,title)
    slider  
  end

  # TODO: add text box, add button
  
end


def register_loader( cla )
  $importer.add_ruby_loader( cla )
end
