# Example of loader class.

# See "example0.dat0" file for sample data for this loader.
# Each line in data file contains radius, and loader will create
# sphere model for each line with that radius.

class Example0Loader < Loader

  #   feel(p) is invoked to determine - can this file load data or not?
  #
  #   p.name // file name without extension
  #   p.ext // file extension in lower case, e.g. "dat"
  #   p.name_ext // file name with ext, e.g. "file.dat"
  #   p.first_2k // first 2048 bytes of file data.
  #   p.first_lines // ascii presentation of first2k. If file contains \0, firstlines is cutted to that first \0.
  #   p.path // full file path
  def self.feel(p)
    p.ext == "dat0" ? 1.0 : 0.0
  end

  #   load(p) is invoked to load data, if this script is winner of feelings
  def load(p)
    file = File.new( p.path , "r")

    m = add_model( "Vici " + p.name_ext )

    t = 0
    while line = file.gets
      radius = line.to_f
      t = t+radius
      m.add_sphere( t,0,0,radius, 33, 22 )
    end

    file.close
  end

end