# Another example of loader class.

# See "example1.dat" file for sample data for this loader.
# File contains one line : "sphere RADIUS", and loader will create
# sphere model for that radius.

class Example1Loader < Loader

  #   feel(p) is invoked to determine - can this file load data or not?
  #
  #   p.name // file name without extension
  #   p.ext // file extension in lower case, e.g. "dat"
  #   p.name_ext // file name with ext, e.g. "file.dat"
  #   p.first_2k // first 2048 bytes of file data.
  #   p.first_lines // ascii presentation of first2k. If file contains \0, firstlines is cutted to that first \0.
  #   p.path // full file path
  def self.feel(p)
    # puts "In feel of example1, p.name_ext = #{p.name_ext}"
    # p.name_ext == "example1.dat" ? 1.0 : 0.0
    p.first_lines =~ /^sphere \d+/i ? 0.75 : 0.0
  end

  #   load(p) is invoked to load data, if this script is winner of feelings
  def load(p)
    puts "We are loading..."

    file = File.new( p.path , "r")

    line = file.gets
    radius = line.split[1].to_f

    m = add_model( "Model of Sphere in "+p.name_ext )
    m.add_sphere( 0,0,0,radius, 33, 22 )

    file.close

    puts "Done"
  end

end