# A loader which connects external exe-programs with SharpEye.

# Program rules:
# 1. It's name must contain extension of data files which can be loaded by that program
# Example: my_bindat_loader.exe - it can load, for example, data files with "bindat" extension.
# 2. In feel stage, program will be called with -F flag:, and must return float value in stdout
# Example:
#   my_dat_loader.exe somefile.dat -F
# Example output:
#   0.8
# 3. Program must generate output in "eye" format
# For example of eye format, see 1.eye

# seee http://whynotwiki.com/Ruby_/_Process_management
#include System::IO
#include System::Text

module ExeLoaderMethods

  module ClassMethods
    attr_accessor :exe_file_path

    def feel(p)
      #puts "Invoked EXE FEEL, @exe_file_path=#{exe_file_path}"
      return 0.0 if p.ext.length == 0
      precheck = File.basename(exe_file_path, '.*').downcase.index(p.ext)
      return 0.0 if precheck.nil?

      result = `#{exe_file_path} #{p.path} -F`
      return result.to_f if result.to_f > 0
      0.0
    end
  end

  def self.included(base)
    base.extend(ClassMethods)
  end

  #   load(p) is invoked to load data, if this script is winner of feelings
  def load(p)
    @pipe = IO.popen("#{self.class.exe_file_path} #{p.path}", "w+")
  #  logger.info "Opened process, id=#{@pipe.id}"
  #  return

    file = @pipe
  #  file = File.new( p.path , "r")
  # logger.info "File id = #{file.fileno.to_s}"
  # logger.info file.methods.inspect
  # logger.info "@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@"
  # logger.info file.GetReadableStream.base_stream.class.to_s
    n = 0
    begin
    while true
  #    logger.info "Reading line..."
      line = file.gets
      break if !line
  #    logger.info "Readed!"
      n = n +1

      if line =~ /^#*done!/
        logger.info "Got done command. Finishing."
        break
      end

      if line =~ /add_\w+_list/
        #logger.info "Current stream pos is #{file.pos}. Internals show: #{file.GetReadableStream.base_stream.Position}"
        logger.info "file = #{file.class}"
        logger.info "file.GetReadableStream = #{file.GetReadableStream.class}"
        logger.info "file.GetReadableStream.base_stream = #{file.GetReadableStream.base_stream.class}"
        logger.info "file.GetReadableStream.base_stream.Reader = #{file.GetReadableStream.base_stream.Reader.class}"
        #scene.list_file_stream = file.GetReadableStream.base_stream
        scene.file_stream_reader = file.GetReadableStream.base_stream.Reader
        #scene.list_file_stream.Position = file.pos
      elsif line =~ /{{/
        if line !~ /}}/
        while true
          subline = file.gets
          if not subline
            raise "Unexpected end of {{ .. }} block!"
          end
          line << subline
          if subline =~ /}}/
            break
          end
        end
        end
        line = line.gsub("{{","").gsub("}}","") unless line =~ /^\s*#/
      end

      logger.info "Executing line #{n}: #{line}" if n%5000 == 0

      begin
        eval( line ) unless line =~ /^\s*#/
      rescue NoMethodError
        if created_models.length == 0
          add_model( "#{p.name}.#{p.ext}" )
          retry
        else
          raise
        end
      end

      if line =~ /add_\w+_list/
  #      logger.info "After mass action, we see file pos: #{scene.list_file_stream.Position}"
        #file.seek scene.list_file_stream.Position
  #      scene.list_file_stream = nil
      end

      #logger.info "Executed"
    end
    ensure
  #    file.close
      logger.info "File closed.. hehe"
    end

    @pipe.puts "Thank you!"
    @pipe.close
    logger.info "pid=#{@pipe.id}"

    logger.info "Loaded"

  end

  ##puts "Examining eat_parameter"
  #begin
  #  @exe_file_path = eat_parameter
  ##  puts eat_parameter
  #  puts "Found exe filter for processing: #{@exe_file_path}"
  #rescue
  #  puts "Eat parameter not found. It is needed for this script. => Undefining feel."
  #  undef feel
  #end

end


# Lets find exe programs and
# create a Loader class for each program
co = 0
for p in Dir.glob( File.join(sharpeye_root,"scripting","ExeFilters","*.exe") )
  puts "Installing exe proxy plugin for exe program #{p}"

  e = Class.new(Loader) do
         define_method "name" do
           "ExeLoader class for #{p}"
         end
         include ExeLoaderMethods
  end
  e.exe_file_path = p
  #e.class_variable_set(:@@exe_file_path, p)

  Kernel.const_set "ExeLoader#{co=co+1}", e

  #dynamic_name = "ExeLoader#{co=co+1}"
  #
  #Object.const_set(dynamic_name, Class.new(Loader) {
  #    def name() "ExeLoader for #{p}" end; @exe_file_path = p; include ExeLoaderMethods  }
  #)

  #importer.add_ruby_filter( "Scripting/EyeFormat/exeloader.rb",p )
  #no need here - boot.rb will add all ancestors of Loader class to filters
end