# ".eye" format loader

# Eye format is a ruby-style data format. See 1.eye for example.

class EyeFormatLoader < Loader

  #   feel(p) is invoked to determine - can this file load data or not?
  #
  #   p.ext // file extension in lower case, e.g. "dat"
  #   p.first_2k // first 2048 bytes of file data.
  #   p.first_lines // ascii presentation of first2k. If file contains \0, firstlines is cutted to that first \0.
  #   p.name // file name without extension
  #   p.path // full file path

  def self.feel(p)
    p.ext.downcase == "eye" ? 1.0 : 0.0
  end

  #   load(p) is invoked to load data, if this script is winner of feelings
  def load(p)
    file = File.new( p.path , "r")
  # logger.info "File id = #{file.fileno.to_s}"
  # logger.info file.methods.inspect
  # logger.info "@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@"
  # logger.info file.GetReadableStream.base_stream.class.to_s
    n = 0
    begin
    while line = file.gets
      n = n +1

      if line =~ /^#*done!/
        logger.info "Got done command. Finishing."
        break
      end

      if line =~ /add_\w+_list/
        #logger.info "Current stream pos is #{file.pos}. Internals show: #{file.GetReadableStream.base_stream.Position}"
        logger.info "Getting base stream. It's class is: #{file.GetReadableStream.base_stream.class}"
        scene.list_file_stream = file.GetReadableStream.base_stream
        scene.list_file_stream.Position = file.pos
      elsif line =~ /{{/
        if line !~ /}}/
        while true
          subline = file.gets
          if not subline
            raise "Unexpected end of {{ .. }} block!"
          end
          line << subline
          if subline =~ /}}/
            break
          end
        end
        end
        line = line.gsub("{{","").gsub("}}","") unless line =~ /^\s*#/
      end

      logger.info "Executing line #{n}: #{line}"

      begin
        eval( line ) unless line =~ /^\s*#/
      rescue NoMethodError
        if created_models.length == 0
          add_model( "#{p.name}.#{p.ext}" )
          retry
        else
          raise
        end
      end

      if line =~ /add_\w+_list/
        logger.info "After mass action, we see file pos: #{scene.list_file_stream.Position}"
        file.seek scene.list_file_stream.Position
        scene.list_file_stream = nil
      end

      #logger.info "Executed"
    end
    ensure
      file.close
      logger.info "File closed"
    end

    logger.info "Loaded"

  end

end