require "sharpeye"

require 'Triangulator'
include System::Collections::Generic

require 'PloshadZuba/triselector'


class PavelProSurfaceLoader < Loader

  #   feel(p) is invoked to determine - can this file load data or not?
  #
  #   p.ext // file extension in lower case, e.g. "dat"
  #   p.first_2k // first 2048 bytes of file data.
  #   p.first_lines // ascii presentation of first2k. If file contains \0, firstlines is cutted to that first \0.
  #   p.name // file name without extension
  #   p.path // full file path

  def self.feel(p) # Файл определяем по наличию "X Y Z" в первой строке
    p.first_lines =~ /X\s+Y\s+Z/ ? 0.5 : 0.0
  end

  include TriSelector
  
  #   load(p) is invoked to load data, if this script is winner of feelings
  def load(p)
    @m = m = add_model( "#{p.name} points" )

    file = File.new( p.path , "r")
    file.gets

    vertices = List.of(Triangulator::Geometry::Point).new

    while ((pos = file.pos) and (line = file.gets))
        items = line.strip.split(/\s+/) [0..2]
        next if items.length == 0
        x,y,z = items.map{ |i| i.to_f }
        # puts "Got items: #{items.inspect}, so xyz is #{x} #{y} #{z}"

        m.hit_value = pos #vertices.count
        m.add_sphere( x, y, z, 0.10, 3, 2 )
        vertices << Triangulator::Geometry::Point.new(x,y,z)
    end
 
    puts "Triangulating #{vertices.count} nodes"
    tris = Triangulator::Delauney::Triangulate(vertices)
    puts "We got #{tris.count} triangles"

    @m2 = m2 = add_model( "#{p.name} surface" )
    vertices.each{ |v| m2.add_node( v.X, v.Y, v.Z ) }
    tris.each{ |t| m2.add_triangle( t.p2, t.p1, t.p3 ) }

    start_selector( m2, 0.5 )
    
  #            List<Triangulator.Geometry.Triangle> tris = Triangulator.Delauney.Triangulate(Vertices);


    m3 = add_model( "#{p.name} line" )
    m3.color_str = "red"
    m3pt1 = nil
    m3pt2 = nil

    
    m.hit_tested do |sender, args|
      file.seek( sender.hit_value, IO::SEEK_SET)
      puts "File #{p.name} offset #{sender.hit_value+1}: #{file.gets}"
      
      m3pt1 = m3pt2
      m3pt2 = sender.hit_point_1
      if m3pt1
        m3.add_line( m3pt1, m3pt2 )
      end
      m3.refresh


      #pt2 =
      #pt  = Point3D.new( slice[k][0],  slice[k][1],   slice[k][2] )
      #pt2 = Point3D.new( slice[k+1][0],slice[k+1][1], slice[k+1][2] )
      #m.add_line pt, pt2 if dist < porog

  #    puts "Hello there, sender is #{sender.inspect}, args are #{args.inspect}"
    end

    puts "Well done"
  end

end