module ZubeMath

  # adder = Proc.new{ |triangle_index,a,b,c| blabla }

  def find_poverhnost_zuba( model, mid_x,mid_y,mid_z,mid_r,adder,algo=1 )
    # Предполагаемый центр зуба
    cx,cy,cz = mid_x,mid_y,mid_z
    mid_r2 = mid_r / 4.0 # 3.7

    mesh = model.mesh
    tris = mesh.triangle_indices
    co = tris.count
    i = 0
    while i < co do
      a = mesh.positions[ tris[i] ]
      b = mesh.positions[ tris[i+1] ]
      c = mesh.positions[ tris[i+2] ]
      x = (a.x+b.x+c.x)/3
      y = (a.y+b.y+c.y)/3
      z = (a.z+b.z+c.z)/3
      dist_to_mid = ((x-mid_x)**2 + (y-mid_y)**2  + (z-mid_z)**2)**0.5
      #@msel.node_hit_value = i/3
      # Выбираем только то, что недалеко (< mid_r) от центра
      # puts dist_to_mid
      if dist_to_mid <= mid_r
        normal = Vector3D.CrossProduct( b-a,c-a )
        normal.normalize

        #m = face[0]
        #tr = face[1]
        #n = face[2]
        #nz = n[2]
        nx,ny,nz = normal.x, normal.y, normal.z

        ok = false
        if (algo == 0 and nz>0.5) # смотрит вверх?
          ok=true
        else
          #x,y,z = tr[2]
          rx,ry = (x-cx),(y-cy)
          # rx,ry - вектор из 3-й точки треугольника в центр зуба
          # nx,ny - нормаль треугольника в плоскости
          # если нормаль направлена примерно в центр...
          scal = nx*rx + ny*ry
          if scal <= 0.2 #smotrit v centr zuba
            ok=true
          elsif (cx-x).abs < mid_r2 and (cy-y).abs < mid_r2
            # безусловно берем тех, кто все-же достаточно близенько
            ok=true
          end
        end

        adder.call( i,a,b,c ) if ok
      end

      puts "**************************************** #{i}" if i%10000==0
      i=i+3
    end

  end

  def find_ploshad_modeli( model )
    mesh = model.mesh
    tris = mesh.triangle_indices
    co = tris.count
    i = 0
    pl = 0.0
    pl2 = 0.0
    while i < co do
      a = mesh.positions[ tris[i] ]
      b = mesh.positions[ tris[i+1] ]
      c = mesh.positions[ tris[i+2] ]
      x0 = a.x
      y0 = a.y
      z0 = a.z
      x1 = b.x
      y1 = b.y
      z1 = b.z
      x2 = c.x
      y2 = c.y
      z2 = c.z

      x1 -= x0
      x2 -= x0
      y1 -= y0
      y2 -= y0
      z1 -= z0
      z2 -= z0

      pl += ((y1*z2 - y2*z1)**2 + (x1*z2 - x2*z1)**2  + (x1*y2 - x2*y1)**2)**0.5
      pl2 += ((x1*y2 - x2*y1)**2)**0.5

      #puts "**************************************** #{i}" if i%10000==0
      i=i+3
    end

    return [pl,pl2]
#    g.puts m.join
#    x1,y1,z1=tr[1]
#    x2,y2,z2=tr[2]
#
#    x1 -= tr[0][0]
#    x2 -= tr[0][0]
#    y1 -= tr[0][1]
#    y2 -= tr[0][1]
#    z1 -= tr[0][2]
#    z2 -= tr[0][2]
#
#    pl += ((y1*z2 - y2*z1)**2 + (x1*z2 - x2*z1)**2  + (x1*y2 - x2*y1)**2)**0.5
  end

#
#f=File.open(ARGV[0],"r")
#g=File.open(ARGV[1] || "out.stl","w")
#g.puts "solid vcg\n"
#mid_x,mid_y,mid_z,mid_r = ARGV[2].to_f,ARGV[3].to_f,ARGV[4].to_f,ARGV[5].to_f
#
#count=0
#zuba=[]
#cx,cy,cz,zubcount=0,0,0,0
#
#while line=f.gets
#count=count+1
#puts count if count%1024==0
#
#next unless line =~ /facet normal (.+)$/
#m = []
#m << line
#6.times{ m << f.gets }
#
#nx,ny,nz = $1.split(/ /)[0..3].map{ |v| v.to_f }
#
#tr=[]
#x,y,z=0,0,0
#for i in 0...3 do
# vline=m[i+2]
# vline =~ /vertex  (.+)/
## puts vline
# rrr = $1.split(/ /)
## puts rrr.inspect
# x,y,z = rrr[0..3].map{ |v| v.to_f }
# tr << [x,y,z]
#end
#
#dist_to_mid = ((x-mid_x)**2 + (y-mid_y)**2  + (z-mid_z)**2)**0.5
#
## Выбираем только то, что недалеко (< mid_r) от центра
#
#if dist_to_mid <= mid_r
##if z>6 and x>20 and y<-2.5
##mi na zube
#cx+=x
#cy+=y
#cz+=z
#zubcount+=1
#zuba << [m,tr,[nx,ny,nz]]
#end
#
#end
#
#cx /= zubcount
#cy /= zubcount
#cz /= zubcount
#
## Предполагаемый центр зуба
#cx,cy,cz = mid_x,mid_y,mid_z
#
#pl = 0
#
## face - это 1 треугольник, бежим по ним
#for face in zuba do
#  m = face[0]
#  tr = face[1]
#  n = face[2]
#  nz = n[2]
#
#  ok = false
#  if nz>0.5 # смотрит вверх?
#    ok=true
#  else
#    x,y,z = tr[2]
#    rx,ry = (x-cx),(y-cy)
#    # rx,ry - вектор из 3-й точки треугольника в центр зуба
#    # nx,ny - нормаль треугольника в плоскости
#    # если нормаль направлена примерно в центр...
#    scal = nx*rx + ny*ry
#    if scal <= 0.2 #smotrit v centr zuba
#      ok=true
#    elsif (cx-x).abs < 3.7 and (cy-y).abs < 3.7
#      # безусловно берем тех, кто все-же достаточно близенько
#      ok=true
#    end
#  end
#
#  if ok
#    g.puts m.join
#    x1,y1,z1=tr[1]
#    x2,y2,z2=tr[2]
#
#    x1 -= tr[0][0]
#    x2 -= tr[0][0]
#    y1 -= tr[0][1]
#    y2 -= tr[0][1]
#    z1 -= tr[0][2]
#    z2 -= tr[0][2]
#
#    pl += ((y1*z2 - y2*z1)**2 + (x1*z2 - x2*z1)**2  + (x1*y2 - x2*y1)**2)**0.5
#
#  end
#
#
#end
#
#g.puts "endsolid vcg\n"
#
#puts "PLOSHAD ZUBA = #{pl}"

end