# read stl files..

class StlLoader < Loader

  #   z-  ?   false,  
  attr_accessor :z_normal_more_or_equal

  def self.feel(p)
    #puts p.ext
    res = p.ext == "stl" ? 1.0 : 0.0
    #puts res
    res
  end

  def load(p)
    m = add_model( "#{p.name} zubik" )

    puts "Loading strl #{p.path}"

    fmt = p.first_lines =~ /solid vcg/mi ? :text : :binary
    puts "Format is #{fmt}"
    if fmt == :text
      read_text(p,m)
    else
      read_binary(p,m)
    end

    puts "Done"
    m
  end

  def read_text(p,m)
    f = File.new( p.path , "r")

    count=0
    while line=f.gets
      count=count+1
      # next if count%5 != 0
      if count%1000==0
         pct = 100 * f.pos / p.file_size
         puts "Read #{pct}%, #{count} lines ##nolog"
      end
      next unless line =~ /facet normal (.+)$/

      triangle_data = []
      triangle_data << line
      6.times{ triangle_data << f.gets }

      nx,ny,nz = $1.split(/ /)[0..3].map{ |v| v.to_f }

      tr=[]
      x,y,z=0,0,0
      for i in 0...3 do
        vline = triangle_data[i+2]
        vline =~ /vertex  (.+)/
        rrr = $1.split(/ /)
        x,y,z = rrr[0..3].map{ |v| v.to_f }
        tr << [x,y,z]
      end

      m.add_triangle_separate(
                  tr[0][0],tr[0][1],tr[0][2],
                  tr[1][0],tr[1][1],tr[1][2],
                  tr[2][0],tr[2][1],tr[2][2] ) if !@z_normal_more_or_equal or normal[2] >= @z_normal_more_or_equal

    end #while
    f.close

  end


  #from https://github.com/SketchUp/sketchup-stl/blob/master/src/sketchup-stl/jf_stl_importer.rb
  #format desk: http://en.wikipedia.org/wiki/STL_(file_format)#Binary_STL
  def read_binary(p,m)
    f = File.new( p.path , "rb")

    header = ""
    80.times {
      c = f.read(1).unpack('c')[0]
      if c <= 32 or c > 126 or c.nil?
        c = ?.
      end
      header << c
    }
    int_size = [42].pack('i').size
    float_size = [42.0].pack('f').size
    len = f.read(int_size).unpack('i')[0]
    puts "float_size, int_size, len = #{float_size},#{int_size},#{len}"

    count = 0

    @stl_conv = 0.1
    while !f.eof
      count=count+1

      nval = f.read(3 * float_size)
      normal = nval.unpack('fff')
      v1 = f.read(3 * float_size).unpack('fff')
      v1.map!{|e| e * @stl_conv}
      v2 = f.read(3 * float_size).unpack('fff')
      v2.map!{|e| e * @stl_conv}
      v3 = f.read(3 * float_size).unpack('fff')
      v3.map!{|e| e * @stl_conv}
      # UINT16 Attribute byte count? (STL format spec)
      abc = f.read(2)

      if count%10000==0
         pct = 100 * f.pos / p.file_size
         puts "Read #{pct}%, #{count} triangles ##nolog"
      end

      # pts << [v1, v2, v3]
      m.add_triangle_separate(
                  v1[0],v1[1],v1[2],
                  v2[0],v2[1],v2[2],
                  v3[0],v3[1],v3[2] ) if !@z_normal_more_or_equal or normal[2] >= @z_normal_more_or_equal
                  #### if normal[2] >= 0

     end # while
    f.close

  end
end