#   .  .

$LOAD_PATH.unshift File.expand_path(File.dirname(__FILE__))
# $LOAD_PATH.unshift "."

require "read_stl.rb"
require 'triselector.rb'
require "d_zube_math.rb"

class ZubLoader < StlLoader

  include TriSelector
  include ZubeMath

  #require File.join( File.expand_path(File.dirname(__FILE__)),"lib","c_algo.rb")


  #   feel(p) is invoked to determine - can this file load data or not?
  #
  #   p.ext // file extension in lower case, e.g. "dat"
  #   p.first_2k // first 2048 bytes of file data.
  #   p.first_lines // ascii presentation of first2k. If file contains \0, firstlines is cutted to that first \0.
  #   p.name // file name without extension
  #   p.path // full file path

  def self.feel(p)
    #puts p.ext
    res = p.ext == "stl" ? 1.5 : 0.0
    #puts res
    res
  end

  def load(p)
     self.z_normal_more_or_equal = 0.21
    @m = super
    after_load(p)

    g = scene.GetModelGroupByName( "Axes" ) [0]
    pa = scene.GetModelGroupPropertyAccessor( g )
    pa.SetProperty("Visible",false)
  end

  def after_load(p)
    @modelpath = p.path

    scene.lights[0].light.position = Point3D.new(5,0,2)
    scene.lights[1].light.position = Point3D.new(-3.71108371907462,0.060559881765696,1.99129211609797)

    #@m3 = add_model( "kontur" )
    #@m3.color_str = "red"
    #@m3pt1 = nil
    #@m3pt2 = nil

    start_selector( @m, 0.1 )
    
    @m.hit_tested do |sender, args|
      begin
			  hit_eval_2(sender)
      rescue => m
       puts "Exception! #{m.message} #{m.backtrace[0..5].join('\n')}"
      end
    end

    engine.add_hot_key("F12",Visualizator::KeyBinding::OnEvent.new { clear_msel; puts "##title" })
  end
  
  alias_method :orig_msel_to_model, :msel_to_model
  def msel_to_model
    orig_msel_to_model
    pl = find_ploshad_modeli( @msel )
    puts "Ploshad Zuba = #{pl} ##title"
  end
  
  # algo N 2
  def hit_eval_2(sender)
    adder = Proc.new{ |triangle_index,a,b,c| add_tri_to_msel(triangle_index,a,b,c) }
    r = 0.6
    find_poverhnost_zuba( @m, sender.hit_point_1.x, sender.hit_point_1.y, sender.hit_point_1.z, r, adder )
    msel_to_model
  end

  def hit_eval_1(sender)
    f = File.join( File.expand_path(File.dirname(__FILE__)),"lib","b.rb" )
    out = @modelpath + "zubpart-temp.stl"
    r = 5
    cmd = "ruby #{f} #{@modelpath} #{out} #{sender.hit_point_1.x} #{sender.hit_point_1.y} #{sender.hit_point_1.z} #{r}"
    puts "Calling: #{cmd}"
    system( cmd )
    engine.load_data out
  end

  def hit_line(sender)
      # file.seek( sender.hit_value, IO::SEEK_SET)
      #puts "File #{p.name} offset #{sender.hit_value+1}: #{file.gets}"

      @m3pt1 = @m3pt2
      @m3pt2 = sender.hit_point_1
      if @m3pt1
        @m3.add_line( @m3pt1, @m3pt2 )
      end
      @m3.refresh

      #pt2 =
      #pt  = Point3D.new( slice[k][0],  slice[k][1],   slice[k][2] )
      #pt2 = Point3D.new( slice[k+1][0],slice[k+1][1], slice[k+1][2] )
      #m.add_line pt, pt2 if dist < porog

  #    puts "Hello there, sender is #{sender.inspect}, args are #{args.inspect}"  
  end

end