# Интерактивный шарик-селектор по поверхности моделей. В оригинале сделан для зуба.
module TriSelector

  def start_selector( model,radius=0.7 )
    @msource = model
    @mid_r = radius
    
    @msel = add_model( "SELECTED" ) # #{model.name}
    @msel.color_str = "blue"
    @msel.back_color_str = "blue"

    @mhit = add_model( "BALL" ) # #{model.name}
    @mhit.color_str = "cyan"
    @mhit.opacity = 0.5
    q=4
    @mhit.add_sphere( 0,0,0, @mid_r, 3*q, 2*q )

    @lx,@ly,@lz = 0,0,0

    @hcount = 0
    @event_surface = engine.find_name("eventSurface")
    @event_surface.mouse_move.remove method(:mouse_mover)
    @event_surface.mouse_move.add method(:mouse_mover)
    
    clear_msel
  end

  def clear_msel
    # @msel - model s vidileniem
    @msel.reset
    # @mselsources - nomera (t.e. ssilki) na ishodnie indexi treugolnikov v @msource
    @mselsources = Array.new
    # @mselnodes - massiv is tochek Point3d - soderjit nabor treugolnikov tekushego videlenia
    @mselnodes = Array.new

    mesh = @msource.mesh
    tris = mesh.triangle_indices
    co = tris.count / 3

    # @mmask holds 0/1 - if triangle with i/3 is included in selection
    @mmask = Array.new( co )
  end

  def msel_to_model
    @msel.reset

    co = @mselnodes.count
    i = 0
    puts "msel_to_model, count=#{co}"
    while i < co do
      #puts "adding #{i}: #{@mselnodes[ i ].inspect} #{@mselnodes[ i+1 ].inspect} #{@mselnodes[ i+2 ].inspect}"
      @msel.add_triangle_separate @mselnodes[ i ],@mselnodes[ i+1 ],@mselnodes[ i+2 ]
      i=i+3
    end

    @msel.refresh
  end

  # Здесь i - это индекс первой вершины треугольника в model.triangle_indices
  def add_tri_to_msel( i,a,b,c )
    if @mmask[ i/3 ] != 1
      #puts "added #{i} to msel, #{a.inspect} #{b.inspect} #{c.inspect}"
      @mselnodes.push a
      @mselnodes.push b
      @mselnodes.push c
      @mselsources.push (i/3)
      @mmask[ i/3 ] = 1
    end
  end

  # Здесь i - это индекс первой вершины треугольника в model.triangle_indices
  # После удалений надо вызвать: (idea: упростить, сделав авто-флаг и проверять его в msel_to_model)
  #   @mselnodes.compact!;
  #   @mselsources.compact!
  def remove_tri_from_msel( i )
    source_tri = @mselsources[ i/3 ]
    @mmask[ source_tri ] = nil
    @mselnodes[ i ] = nil
    @mselnodes[ i+1 ] = nil
    @mselnodes[ i+2 ] = nil
    @mselsources[ i/3 ] = nil
  end

  # Обработчик события "двигается мышка"
  def mouse_mover( sender, args )
  begin
    # return if not args.left_button.to_s == "Pressed"
    operation = Keyboard.IsKeyDown(Key.LeftAlt) ? :add : ( Keyboard.IsKeyDown(Key.RightAlt) ? :remove : :none  )
    return if operation == :none
  
    p = args.get_position( @event_surface )
    hit = engine.FindModelByPoint( p, @msource ) # see RayMeshGeometry3DHitTestResult
    # Esli ne popali, poishem na videleniee
    hit = engine.FindModelByPoint( p, @msel ) if not hit
    puts "mouse move #{@hcount = @hcount+1}!, #{args.left_button}, #{p.x} #{p.y}, operation=#{operation} " + "Hit test: #{hit ? hit.PointHit.inspect : false}"

    if hit 
      mid_x,mid_y,mid_z = hit.PointHit.X,hit.PointHit.Y,hit.PointHit.Z
      #puts mid_x.inspect
      # mid_r = 0.3
      
      x,y,z = @lx,@ly,@lz
      d1 = ((x-mid_x)**2 + (y-mid_y)**2  + (z-mid_z)**2)**0.5

      @mhit.x = mid_x
      @mhit.y = mid_y
      @mhit.z = mid_z
      #@mhit.refresh
      # vihod esli sdvig sharika malenkiy
      porog = @mid_r * 0.5 # (operation == :add ? 0.5 : 0.3)
      return if d1 < porog
      @lx,@ly,@lz = @mhit.x, @mhit.y, @mhit.z

      have_changes = false
      if operation == :add 
        mesh = @msource.mesh
        tris = mesh.triangle_indices
        co = tris.count
        i = 0
        while i < co do
          if @mmask[ i/3 ] != 1
            a = mesh.positions[ tris[i] ]
            b = mesh.positions[ tris[i+1] ]
            c = mesh.positions[ tris[i+2] ]
            x = (a.x+b.x+c.x)/3
            y = (a.y+b.y+c.y)/3
            z = (a.z+b.z+c.z)/3
            dist_to_mid = ((x-mid_x)**2 + (y-mid_y)**2  + (z-mid_z)**2)**0.5
            #@msel.node_hit_value = i/3
            if dist_to_mid <= @mid_r
              add_tri_to_msel( i,a,b,c )
              have_changes = true
            end
          end
          puts i if i%10000==0
          i=i+3
       end
     else
        # removing ....
       co = @mselnodes.count
       i = 0
       while i < co do
           a = @mselnodes[ i ]
           b = @mselnodes[ i+1 ]
           c = @mselnodes[ i+2 ]
           x = (a.x+b.x+c.x)/3
           y = (a.y+b.y+c.y)/3
           z = (a.z+b.z+c.z)/3
           dist_to_mid = ((x-mid_x)**2 + (y-mid_y)**2  + (z-mid_z)**2)**0.5

           if dist_to_mid <= @mid_r
             remove_tri_from_msel( i )
             have_changes = true
           end
         puts i if i%10000==0
         i=i+3
       end
       @mselnodes.compact!
       @mselsources.compact!
     end
    end

    msel_to_model() if have_changes
  
    args.handled = true
  rescue => m
   puts "Exception! #{m.message} #{m.backtrace[0..5].join('\n')}"
  end
  end
  

end
