require "sharpeye"

require 'Triangulator'
include System::Collections::Generic

class SerdceSpiralLoader < Loader

  #   feel(p) is invoked to determine - can this file load data or not?
  #
  #   p.ext // file extension in lower case, e.g. "dat"
  #   p.first_2k // first 2048 bytes of file data.
  #   p.first_lines // ascii presentation of first2k. If file contains \0, firstlines is cutted to that first \0.
  #   p.name // file name without extension
  #   p.path // full file path

  def self.feel(p) # Файл определяем по наличию "X Y Z" в первой строке
    p.first_lines.split(/\n/)[0].length == 73 and p.ext == "txt" ? 1.4 : 0.0
    # =~ /X\s+Y\s+Z/ ? 2.6 : 0.0
  end

  #   load(p) is invoked to load data, if this script is winner of feelings
  def load(p)
    scene.lights[0].light.position = Point3D.new(8,-9,135)
    scene.lights[0].brightness = @psi_zero ? 0.75 : 0.45

    @p = p
    @model  = add_model( "#{p.name} serdce" )
    #mis = add_model( "#{p.name} mishca" )
    #mis.color_str = "red"
    #mis.back_color_str = ""

    @global = scene.add_model_group( "#{p.name} gamma slices" )
    @groups = []
    @surfaces = []
    @lines = []
    @balls = []
    for i in (1..5) do 
      @groups << scene.add_model_group( "Gamma N#{i}",@global )

      @balls << scene.add_model( "Points N#{i}",nil,true,@groups.last )
      @lines << scene.add_model( "Lines N#{i}",nil,true,@groups.last )
      @surfaces << scene.add_model( "Surface N#{i}",nil,true,@groups.last )
    end

    file = File.new( p.path , "r")

    n = 0
    nvec = 100
    merids = 10
    @gammas = {}
    @datas = []
    @fis = {}
    @psis = {}

    @psi_zero ||= false

    puts "@psi_zero = #{@psi_zero}"
    while ((pos = file.pos) and (line = file.gets))
      @datas[n] = line.unpack("a8a8a8a8a8a8a8a8a8").map{ |e| e.to_f } # gamma,psi,fi,x,y,z,vx,vy,vz
      next if @psi_zero and @datas[n] [1] != 0.0 # 0.001
      gamma = @datas[n][ 0 ]
      psi = @datas[n][ 1 ]
      fi = @datas[n][ 2 ]

      @gammas[ gamma ] ||= []
      @gammas[ gamma ] << n
      @psis[ psi ] ||= []
      @psis[ psi ] << n
      @fis[ fi ] ||= []
      @fis[ fi ] << n
      
      n += 1
      puts "line #{n}" if n%1000 == 0
    end
    @gamma_keys = @gammas.keys.sort
    @fi_keys = @fis.keys.sort
    @psi_keys = @psis.keys.sort
    
    add_slider( @model, "Fi0",1,@fi_keys.length,1 ) { |v| @fi0_index = v-1; show_spiral }
    @fi0_index = 0
    add_slider( @model, "FiMax",1,@fi_keys.length,@fi_keys.length ) { |v| @fimax_index = v-1; show_spiral }
    @fimax_index = @fi_keys.length-1

#    add_checkbox( @model, "Psi=0", false ) { |v| @psi_zero = v; show_gamma_many }
#    @psi_zero = false

    add_slider( @model, "Sphere radius",0,10,1 ) { |v| @sphere_radius = v / 10.0; show_gamma_many }
    @sphere_radius = 0.10
    
    add_slider( @model, "Line radius",0,40, 2 ) { |v| @line_radius = v / 40.0; show_gamma_many }
    @line_radius = 2 * 0.10 / 4.0
    
    add_checkbox( @model, "Show surfaces", true ) { |v| @show_surface = v; show_gamma_many }
    @show_surface = true

    @sliders = []
    for i in (1..5) do 
      @sliders << add_slider( @model, "Gamma slice #{i}", 0, @gamma_keys.length, 0 ) { |v| show_gamma_many }
    end
    @sliders[0].value = 1
    show_gamma_many

    file.close

    puts "Well done"
    puts "Got gammas total #{@gammas.keys.length} = #{@gammas.keys.sort}"
  end

  def show_spiral
    begin
    puts "Show spiral called"
    fi0 = @fi_keys[ @fi0_index ]
    fimax = @fi_keys[ @fimax_index ] * 3
    gammamin = @gamma_keys.first
    gammamax = @gamma_keys.last
    eps = 0.07

    puts "fi_0=#{fi0}, fi_max=#{fimax} ##title"

    model_index = 0
    ball_model = @balls[ model_index ]
    lines_model = @lines[ model_index ]
    surf_model = @surfaces[ model_index ]
    [ball_model,lines_model,surf_model].each{ |m| m.reset }

    vertices_for_tri = List.of(Triangulator::Geometry::Point).new
    
    for fi_index in (@fi0_index .. @fimax_index) do
      fi = @fi_keys[ fi_index ]
      gamma_evaled_arr = []
      for fi_celoye in [-1,0,1] do
        this_fi = fi + fi_celoye * 2 * Math::PI
        gamma_evaled_arr << (this_fi - fi0) * (gammamax - gammamin) / fimax
      end

      puts "Inspecting slice fi = #{fi}, evaled gamma arr = #{gamma_evaled_arr}"
      
      # lets find points!...
      nearest_index_hash = {} #hash by psi
      nearest_dist_hash = {}
      for i in @fis[ fi ] do
        gamma_it,psi_it,fi_it,x,y,z,vx,vy,vz = @datas[ i ]
        for gamma_evaled in gamma_evaled_arr do
          dist = (gamma_it - gamma_evaled).abs
          nearest_dist_hash[ psi_it ] ||= dist+1
          if dist < eps and dist < nearest_dist_hash[ psi_it ]
            nearest_dist_hash[ psi_it ] = dist
            nearest_index_hash[ psi_it ] = i
  				  #ball_model.add_sphere( x, y, z, @sphere_radius, 3, 2 )          
          end
        end

      end # indices in @datas for that fi
      #puts "nearest_index_hash = #{nearest_index_hash.inspect}"
      
      nearest_index_hash.values.each do |i|
        gamma_it,psi_it,fi_it,x,y,z,vx,vy,vz = @datas[ i ]
        ball_model.add_sphere( x, y, z, @sphere_radius, 3, 2 )
        vertices_for_tri << Triangulator::Geometry::Point.new(fi_it,psi_it,i)
      end

    end # going from fi0_index to fimax_index
    
    ball_model.refresh

    cache_name = "serdce-#{@p.path}-#{@p.time}-spiral-#{@fi0_index}-#{@fimax_index}" ## #{File.mtime(__FILE__)}"
    tris = scene.cache_read( cache_name )
    if tris.nil?
      puts "Triangulating #{vertices_for_tri.count} nodes for spiral surface ##start"
      tris = Triangulator::Delauney::Triangulate(vertices_for_tri)
      puts "We got #{tris.count} triangles ##stop"
      scene.cache_write( cache_name,tris)
    end

    surf_model.reset 
    vertices_for_tri.each{ |v| 
      gamma_it,psi_it,fi_it,x,y,z,vx,vy,vz = @datas[ v.Z.to_i ]
      surf_model.add_node( x,y,z ) 
    }
    t0 = 0
    tris.each{ |t| surf_model.add_triangle_trusted( t0+t.p2, t0+t.p1, t0+t.p3 ) }
    surf_model.refresh

    rescue => m
      puts "Exception!"
      puts m.message
      puts m.backtrace
    end
  end
  
  def show_gamma( gamma_index,reset_model = true,model_index = 0 )
    return nil if gamma_index <= 0

    gamma = @gamma_keys[ gamma_index-1 ]
    indices = @gammas[ gamma ]
    if indices.nil?
      puts "Data with gamma=#{gamma} not found!"
      return nil
    end

    ball_model = @balls[ model_index ]
    lines_model = @lines[ model_index ]
    surf_model = @surfaces[ model_index ]

    [ball_model,lines_model,surf_model].each{ |m| m.reset }

    xx,yy,zz = nil,nil,nil

    show_lines = @line_radius > 0
    show_spheres = @sphere_radius > 0 and (show_lines and @line_radius < @sphere_radius)
    
    show_surface = @show_surface

    vertices_for_tri = List.of(Triangulator::Geometry::Point).new

    for i in indices do
      gamma,psi,fi,x,y,z,vx,vy,vz = @datas[ i ]

      if show_spheres
        ball_model.add_sphere( x, y, z, @sphere_radius, 3, 2 )
      end

      if show_lines and xx and z == zz
        lines_model.add_line( Point3D.new(x, y, z), Point3D.new( xx,yy,zz ),@line_radius, 6 ) #r / 4.0
      end

      if show_surface and z == zz
        vertices_for_tri << Triangulator::Geometry::Point.new(x,y,z)
      end
      
      xx,yy,zz = x,y,z
    end

    if show_surface
      cache_name = "serdce-#{@p.path}-#{@p.time}-gamma-#{gamma}-v7" ## #{File.mtime(__FILE__)}"
      tris = scene.cache_read( cache_name )
      if tris.nil?
        puts "Triangulating #{vertices_for_tri.count} nodes for gamma=#{gamma} ##start"
        tris = Triangulator::Delauney::Triangulate(vertices_for_tri)
        puts "We got #{tris.count} triangles ##stop"
        scene.cache_write( cache_name,tris)
      else
        puts "CACHE HIT for gamma=#{gamma}"
      end
      
      puts "Adding points and triangles to model ##start"
      m2 = surf_model

      debug = false
      if debug
        @armodel ||= add_model("arrows debug")
        @armodel.reset(true)
        tris.each{ |t|
          r = 0.1
          @armodel.add_arrow( vertices_for_tri[ t.p2 ].to_point, vertices_for_tri[ t.p1 ].to_point,r )
          @armodel.add_arrow( vertices_for_tri[ t.p1 ].to_point, vertices_for_tri[ t.p3 ].to_point,r )
          @armodel.add_arrow( vertices_for_tri[ t.p3 ].to_point, vertices_for_tri[ t.p2 ].to_point,r )
        }
        @armodel.refresh
      end

      begin
        t0 = m2.mesh.positions.count
        vertices_for_tri.each{ |v| m2.add_node( v.X, v.Y, v.Z ) }
        #tris.each{ |t| m2.add_triangle( t0+t.p2, t0+t.p1, t0+t.p3 ) }
        tris.each{ |t| m2.add_triangle_trusted( t0+t.p2, t0+t.p1, t0+t.p3 ) }
      end


      puts "Points and triangles added ##stop"
    end

    [ball_model,lines_model,surf_model].each{ |m| m.refresh }

    puts "Gamma=#{gamma} | #{indices.length} points ##title"
    gamma
  end

  def show_gamma_many
    gg = []
    @sliders.each_with_index do |sl,i|
      gg << show_gamma( sl.value.to_i, true, i )
    end
    puts "Gammas: #{gg.compact.sort} ##title"
  end

end