class Latticer < SharpEyeKa #RenderLattice

  @@lattices_counter = {}
  def initialize( group_name = "Lattice" )
    @group = scene.add_model_group( group_name,nil,Contracts::AddModeIfExists.ReturnOld )

    @lattice_number = @@lattices_counter[ group_name ] = (@@lattices_counter[ group_name ] || 0) + 1

    reset
  end

  def reset
    @lattice = {}

    @points = scene.add_model( "Points N#{@lattice_number}",nil,true,@group )
    @lines = scene.add_model( "Lines N#{@lattice_number}",nil,true,@groups )
    @surface = scene.add_model( "Surface N#{@lattice_number}",nil,true,@group )
    @vectors = scene.add_model( "Vectors N#{@lattice_number}",nil,true,@group )
    @vectors.color_str = "red"
    @vectors.back_color_str = ""
  end

  def models
    [@surface,@lines,@points,@vectors]
  end

  def set( x,y,v )
    @lattice[ x ] ||= {}
    @lattice[ x ][ y ] = v
  end

  def get( x,y )
    @lattice[ x ][ y ] rescue nil
  end

  def get_x_keys
    @lattice.keys
  end

  def get_y_keys( x )
    @lattice[ x ].keys
  end

  def make_point( x,y )
    x,y,z = get( x,y )[:xyz]
    Point3D.new(x,y,z)
  end

  def render( opts = {} )
    models.each{ |m| m.reset }

    @show_points = opts[:show_points] || true
    @show_lines  = opts[:show_lines] || false
    @show_vectors  = opts[:show_vectors] || false
    @show_surface  = opts[:show_surface] || false

    @sphere_radius = opts[:sphere_radius] || 0.1
    
    for x in get_x_keys
      val = nil
      for y in get_y_keys(x)
        prev_val = val
        val = get( x,y )

#        val[:xyz]
#        val[:vec]
#        val[:id]

         @points.hit_value = val[:id]
         @points.add_sphere( val[:xyz][0], val[:xyz][1], val[:xyz][2], @sphere_radius, 5, 4 )
        
      end
    end

    @points.refresh
    @lines.refresh
    @vectors.refresh

    # let's make a surface

    if @show_surface

    for i in (0..get_x_keys.length-2)
      fi = get_x_keys.sort[i] 
      fi_next = get_x_keys.sort[i+1] 

      lafi = get_y_keys(fi).sort

      for j in (0..lafi.length-2)
        psi = lafi[ j ]
        psi_next = lafi[ j+1 ]

        if false
          p1 = make_point( fi,psi )
          p2 = make_point( fi,psi_next ) 
          p3 = make_point( fi_next,psi ) 
          p4 = make_point( fi_next,psi_next ) 

          @surface.add_triangle_separate( p1,p2,p3 )
          @surface.add_triangle_separate( p2,p4,p3 )
        else
          p1 = make_point( fi,psi )
          p2 = make_point( fi,psi_next ) 
          p3 = make_point( fi_next,psi ) 
          p4 = make_point( fi_next,psi_next ) 

          @surface.hit_value = get( fi,psi )[:id]
          t = @surface.add_node p1
          @surface.add_node p2
          @surface.add_node p3
          @surface.hit_value = get( fi_next,psi_next )[:id] 
          @surface.add_node p4

          @surface.add_triangle_trusted( t,t+1,t+2 )
          @surface.add_triangle_trusted( t+2,t+1,t+3 )
        end

      end
    end

    @surface.refresh
    end

  end



end