# Класс для загрузки даннх из файлов *.HDR
# Загружает данные из файла *.hdr в переменные объекта: @data, @fis, @psis и т.д
# Предназначен для наследования из него более конкретных загрузчиков (построителей видов отображений)

# old 26.03.2013 Векторное поле: стрелки заменены на цилиндры 

# experiment with...
class String
  def paramize
    self.gsub( /\^\^(\S+)/, "\\1=\#\{\\1\}" )
  end

  def bi(b=binding)
    eval( '"' + paramize + '"',b )
  end
end

require "sharpeye"

require 'Triangulator'
include System::Collections::Generic

require "#{File.expand_path(File.dirname(__FILE__))}/latticer"


class SerdceDataLoader < Loader

  #   feel(p) is invoked to determine - can this file load data or not?
  #
  #   p.ext // file extension in lower case, e.g. "dat"
  #   p.first_2k // first 2048 bytes of file data.
  #   p.first_lines // ascii presentation of first2k. If file contains \0, firstlines is cutted to that first \0.
  #   p.name // file name without extension
  #   p.path // full file path

  def self.feel(p) 
    puts "Invoked feel on Dataloader, p.ext = #{p.ext}"
    p.ext == "hrt" ? 1 : 0
  end

  def load_data(p,options={})
    first_line = p.first_lines.split(/\n/)[0]
    splitted_numbers = first_line.strip.split(/\s+/)
      puts "Got ^^splitted_numbers".bi(binding)
    for sn in splitted_numbers
      minus_index = sn.index("-") 
      if minus_index and minus_index >= 1  # то есть это не первый символ, а значит это слиплись 2 числа
        puts "Got ^^minus_index for ^^sn".bi(binding)
        sn = sn[0..minus_index-1]
        splitted_numbers << "onemorenum" #sn[minus_index..-1]
      end
    end
      puts "Corrected ^^splitted_numbers".bi(binding)

    @numbers_in_line = splitted_numbers.length
    @number_width = (first_line.length() - 1) / @numbers_in_line
    if @number_width != @number_width.to_i
      puts "Bad file: number_width is not integer: (#{first_line.length} -1) / #{@numbers_in_line}"
      return
    end
    @unpack_string = "a#{@number_width}" * @numbers_in_line

    file = File.new( p.path , "r")

    n = 0
    @datas = []
    nvec = 100
    merids = 10
    @gammas = {}
    @fis = {}
    @psis = {}
    @psi_to_index = {}

    @psi_zero ||= false

    puts "Loading with params: ^^@numbers_in_line ^^@number_width ^^@unpack_string ^^@psi_zero".bi(binding)
    
    while ((pos = file.pos) and (line = file.gets))
      @datas[n] = line.unpack( @unpack_string ).map{ |e| e.to_f } # gamma,psi,fi,x,y,z,vx,vy,vz

        next if @psi_zero and @datas[n] [1] != 0.0 # 0.001

      gamma = @datas[n][ 0 ]
      psi = @datas[n][ 1 ]
      fi = @datas[n][ 2 ]

      @gammas[ gamma ] ||= []
      @gammas[ gamma ] << n
      @psis[ psi ] ||= []
      @psis[ psi ] << n
      @fis[ fi ] ||= []
      @fis[ fi ] << n
      
      n += 1
      puts "line #{n}" if n%1000 == 0
    end
    @gamma_keys = @gammas.keys.sort
    @fi_keys = @fis.keys.sort
    @psi_keys = @psis.keys.sort

    # need: psi => index
    # formal: @psi_keys.each_with_index{ |psi, index| psi == psi_iskomoe ? return index : next }
    @psi_to_index = {}
    for i in 0...@psi_keys.length
      @psi_to_index[ @psi_keys[i] ] = i 
    end

    @gammamin = @gamma_keys.first
    @gammamax = @gamma_keys.last

    file.close

    set_scene_lights()

    puts "Data loaded"
  end

  def extract_point( i )
    # gamma,psi,fi,x,y,z,vx,vy,vz = @datas[ i ]
    gamma,psi,fi,x,y,z = @datas[ i ]
    Point3D.new(x,y,z)
  end

  def set_scene_lights
    puts "Loader sets scene lights according to its view"
    scene.lights[0].light.position = Point3D.new(8,-9,135)
    scene.lights[0].brightness = @psi_zero ? 0.75 : 0.45
    scene.lights[1].light.position = Point3D.new(-10,90,-30)
    scene.lights[2].light.position = Point3D.new(80,-100,4)
  end

  def point_hit( sender )
    i = sender.hit_value
    gamma,psi,fi,x,y,z,vx,vy,vz = @datas[ i ]

    @hit_model ||= begin
      scene.add_model( "Serdce click",nil,true )
    end

    @hit_model.reset
    @hit_model.color_str = "purple"
    @hit_model.add_sphere( x, y, z, (@sphere_radius+0.1)*2, 5, 4 )
    @hit_model.refresh

    l = "gamma=%f psi=%f fi=%f x=%f y=%f z=%f vx=%f vy=%f vz=%f" % [gamma,psi,fi,x,y,z,vx,vy,vz]
    puts "Click at data line #{i+1} : #{@datas[i]}"
    puts "Click at data line #{i+1} : #{l}"
  end

  def show_spiral
    begin
    puts "fi0=#{@fi0 / Math::PI} pi, fimax=#{@fimax / Math::PI} pi##title"

    model_index = 0
    ball_model = @balls[ model_index ]
    lines_model = @lines[ model_index ]
    surf_model = @surfaces[ model_index ]
    vec_model = @vectors[ model_index ]
    [ball_model,lines_model,surf_model,vec_model].each{ |m| m.reset }

    lattice = {}

    for i in 0...@datas.length do
      gamma,psi,fi,x,y,z,vx,vy,vz = @datas[ i ]

      eps = 0.015
      for celoye in [-1,0,1] do
        this_fi = fi + celoye * 2 * Math::PI
        gammaform = (this_fi - @fi0) * (@gammamax - @gammamin) / @fimax
        dist = (gamma - gammaform).abs

        if false and i%1000 == 0
          puts "this_fi = #{this_fi}"
          puts "gammaform = #{gammaform}"
          puts "gamma = #{gamma}"
          puts "dist = #{dist}"
        end

        if dist <= eps
          lattice[ this_fi ] ||= {} 
          if lattice[ this_fi ][ psi ] 
            #skip
          else
            lattice[ this_fi ][ psi ] = i
            ball_model.hit_value = i
            ball_model.add_sphere( x, y, z, @sphere_radius, 5, 4 )

            if @show_vectors
              origin = Point3D.new( x,y,z )
              vec = Vector3D.new( 0.5 * vx, 0.5 * vy,0.5 * vz )
              vec_model.hit_value = i
              # vec_model.add_arrow( origin, origin + vec, 0.1 )
              vec_model.add_cylinder( origin - vec, origin + vec, 0.1, true, 10 )
            end

          end
          break # celoye cycle
        end
      end

      puts "data #{i}" if i%1000 == 0
    end
    ball_model.refresh
    vec_model.refresh

#    puts lattice.inspect

    # let's make a surface

    if @show_surface

    for i in (0..lattice.keys.length-2)
      fi = lattice.keys.sort[i] 
      fi_next = lattice.keys.sort[i+1] 

      lafi = lattice[fi].keys.sort
      for j in (0..lattice[fi].keys.length-2)
        psi = lafi[ j ]
        psi_next = lafi[ j+1 ]

        if false
          p1 = extract_point lattice[ fi ][ psi ] 
          p2 = extract_point lattice[ fi ][ psi_next ] 
          p3 = extract_point lattice[ fi_next ][ psi ] 
          p4 = extract_point lattice[ fi_next ][ psi_next ] 

          surf_model.add_triangle_separate( p1,p2,p3 )
          surf_model.add_triangle_separate( p2,p4,p3 )
        else
            surf_model.hit_value = lattice[ fi ][ psi ]
          t = surf_model.add_node extract_point lattice[ fi ][ psi ] 
          surf_model.add_node extract_point lattice[ fi ][ psi_next ] 
          surf_model.add_node extract_point lattice[ fi_next ][ psi ] 
            surf_model.hit_value = lattice[ fi_next ][ psi_next ]
          surf_model.add_node extract_point lattice[ fi_next ][ psi_next ] 

          surf_model.add_triangle_trusted( t,t+1,t+2 )
          surf_model.add_triangle_trusted( t+2,t+1,t+3 )
        end

      end
    end

    surf_model.refresh
    end

    rescue => m
      puts "Exception!"
      puts m.message
      puts m.backtrace
    end

  end
  
  def show_gamma( gamma_index,reset_model = true,model_index = 0 )
    return
    return nil if gamma_index <= 0

    gamma = @gamma_keys[ gamma_index-1 ]
    indices = @gammas[ gamma ]
    if indices.nil?
      puts "Data with gamma=#{gamma} not found!"
      return nil
    end

    ball_model = @balls[ model_index ]
    lines_model = @lines[ model_index ]
    surf_model = @surfaces[ model_index ]

    [ball_model,lines_model,surf_model].each{ |m| m.reset }

    xx,yy,zz = nil,nil,nil

    show_lines = @line_radius > 0
    show_spheres = @sphere_radius > 0 and (show_lines and @line_radius < @sphere_radius)
    
    show_surface = @show_surface

    vertices_for_tri = List.of(Triangulator::Geometry::Point).new

    for i in indices do
      gamma,psi,fi,x,y,z,vx,vy,vz = @datas[ i ]

      if show_spheres
        ball_model.add_sphere( x, y, z, @sphere_radius, 3, 2 )
      end

      if show_lines and xx and z == zz
        lines_model.add_line( Point3D.new(x, y, z), Point3D.new( xx,yy,zz ),@line_radius, 6 ) #r / 4.0
      end

      if show_surface and z == zz
        vertices_for_tri << Triangulator::Geometry::Point.new(x,y,z)
      end
      
      xx,yy,zz = x,y,z
    end

    if show_surface
      cache_name = "serdce-#{@p.path}-#{@p.time}-gamma-#{gamma}-v7" ## #{File.mtime(__FILE__)}"
      tris = scene.cache_read( cache_name )
      if tris.nil?
        puts "Triangulating #{vertices_for_tri.count} nodes for gamma=#{gamma} ##start"
        tris = Triangulator::Delauney::Triangulate(vertices_for_tri)
        puts "We got #{tris.count} triangles ##stop"
        scene.cache_write( cache_name,tris)
      else
        puts "CACHE HIT for gamma=#{gamma}"
      end
      
      puts "Adding points and triangles to model ##start"
      m2 = surf_model

      debug = false
      if debug
        @armodel ||= add_model("arrows debug")
        @armodel.reset(true)
        tris.each{ |t|
          r = 0.1
          @armodel.add_arrow( vertices_for_tri[ t.p2 ].to_point, vertices_for_tri[ t.p1 ].to_point,r )
          @armodel.add_arrow( vertices_for_tri[ t.p1 ].to_point, vertices_for_tri[ t.p3 ].to_point,r )
          @armodel.add_arrow( vertices_for_tri[ t.p3 ].to_point, vertices_for_tri[ t.p2 ].to_point,r )
        }
        @armodel.refresh
      end

      begin
        t0 = m2.mesh.positions.count
        vertices_for_tri.each{ |v| m2.add_node( v.X, v.Y, v.Z ) }
        #tris.each{ |t| m2.add_triangle( t0+t.p2, t0+t.p1, t0+t.p3 ) }
        tris.each{ |t| m2.add_triangle_trusted( t0+t.p2, t0+t.p1, t0+t.p3 ) }
      end


      puts "Points and triangles added ##stop"
    end

    [ball_model,lines_model,surf_model].each{ |m| m.refresh }

    puts "Gamma=#{gamma} | #{indices.length} points ##title"
    gamma
  end

  def show_gamma_many
    gg = []
    @sliders.each_with_index do |sl,i|
      gg << show_gamma( sl.value.to_i, true, i )
    end
    puts "Gammas: #{gg.compact.sort} ##title"
  end

end