# 26.03.2013 Векторное поле: стрелки заменены на цилиндры 

require "#{File.expand_path(File.dirname(__FILE__))}/serdce_data_loader"

#module Serdce

class SerdceSpiralLat < SerdceDataLoader

  def self.feel(p) 
    r = super(p) ? 1.0 : 0.0
    r
  end

  def load(p)
    load_data(p)

    @model  = add_model( "#{p.name} SPIRAL" )
    @p = p

    @lat = Latticer.new "#{p.name} spiral"

    @lat.models.each { |m|
        m.hit_tested do |sender, args|
          point_hit( sender )
        end
    }

    add_slider( @model, "Fi0 (-2pi...6pi)",-100,3*100,0 ) { |v| @fi0 = 2 * Math::PI * v / 100.0 ; show_spiral }
    @fi0 = 0
    add_slider( @model, "FiMax (-2pi...6pi)",-100,3*100,100 ) { |v| @fimax = 2 * Math::PI * v / 100.0 ; show_spiral }
    @fimax = Math::PI * 2

#    add_checkbox( @model, "Psi=0", false ) { |v| @psi_zero = v; show_spiral }
#    @psi_zero = false

    add_slider( @model, "Sphere radius",0,10,1 ) { |v| @sphere_radius = v / 10.0; show_spiral }
    @sphere_radius = 0.10
    
    add_slider( @model, "Line radius",0,40, 2 ) { |v| @line_radius = v / 40.0; show_spiral }
    @line_radius = 2 * 0.10 / 4.0
    
    add_checkbox( @model, "Show surfaces", true ) { |v| @show_surface = v; show_spiral }
    @show_surface = true

    add_checkbox( @model, "Show vectors", false ) { |v| @show_vectors = v; show_spiral }
    @show_vectors = false

    show_spiral
  end

  def point_hit( sender )
    i = sender.hit_value
    gamma,psi,fi,x,y,z,vx,vy,vz = @datas[ i ]

    @hit_model ||= begin
      scene.add_model( "Serdce click",nil,true )
    end

    @hit_model.reset
    @hit_model.color_str = "purple"
    @hit_model.add_sphere( x, y, z, (@sphere_radius+0.1)*2, 5, 4 )
    @hit_model.refresh

    l = "gamma=%f psi=%f fi=%f x=%f y=%f z=%f vx=%f vy=%f vz=%f" % [gamma,psi,fi,x,y,z,vx,vy,vz]
    puts "Click at data line #{i+1} : #{@datas[i]}"
    puts "Click at data line #{i+1} : #{l}"
  end

  def show_spiral
    begin
    puts "fi0=#{@fi0 / Math::PI} pi, fimax=#{@fimax / Math::PI} pi##title"

    for i in 0...@datas.length do
      gamma,psi,fi,x,y,z,vx,vy,vz = @datas[ i ]

      eps = 0.015
      for celoye in [-1,0,1] do
        this_fi = fi + celoye * 2 * Math::PI
        gammaform = (this_fi - @fi0) * (@gammamax - @gammamin) / @fimax
        dist = (gamma - gammaform).abs

        if false and i%1000 == 0
          puts "this_fi = #{this_fi}"
          puts "gammaform = #{gammaform}"
          puts "gamma = #{gamma}"
          puts "dist = #{dist}"
        end

        if dist <= eps
          if @lat.get( this_fi, psi )
            #skip
          else
            @lat.set( this_fi, psi, { :xyz => [x,y,z], :vec => [vx,vy,vz], :id => i } )
          end
          break # celoye cycle
        end
      end

      puts "data #{i} = #{@datas[i]}" if i%1000 == 0
    end

    @lat.render( :show_surface => true )

    rescue => m
      puts "Exception in spiral loader!"
      puts m.message
      puts m.backtrace
    end

  end
  
  def show_gamma( gamma_index,reset_model = true,model_index = 0 )
    return
    return nil if gamma_index <= 0

    gamma = @gamma_keys[ gamma_index-1 ]
    indices = @gammas[ gamma ]
    if indices.nil?
      puts "Data with gamma=#{gamma} not found!"
      return nil
    end

    ball_model = @balls[ model_index ]
    lines_model = @lines[ model_index ]
    surf_model = @surfaces[ model_index ]

    [ball_model,lines_model,surf_model].each{ |m| m.reset }

    xx,yy,zz = nil,nil,nil

    show_lines = @line_radius > 0
    show_spheres = @sphere_radius > 0 and (show_lines and @line_radius < @sphere_radius)
    
    show_surface = @show_surface

    vertices_for_tri = List.of(Triangulator::Geometry::Point).new

    for i in indices do
      gamma,psi,fi,x,y,z,vx,vy,vz = @datas[ i ]

      if show_spheres
        ball_model.add_sphere( x, y, z, @sphere_radius, 3, 2 )
      end

      if show_lines and xx and z == zz
        lines_model.add_line( Point3D.new(x, y, z), Point3D.new( xx,yy,zz ),@line_radius, 6 ) #r / 4.0
      end

      if show_surface and z == zz
        vertices_for_tri << Triangulator::Geometry::Point.new(x,y,z)
      end
      
      xx,yy,zz = x,y,z
    end

    if show_surface
      cache_name = "serdce-#{@p.path}-#{@p.time}-gamma-#{gamma}-v7" ## #{File.mtime(__FILE__)}"
      tris = scene.cache_read( cache_name )
      if tris.nil?
        puts "Triangulating #{vertices_for_tri.count} nodes for gamma=#{gamma} ##start"
        tris = Triangulator::Delauney::Triangulate(vertices_for_tri)
        puts "We got #{tris.count} triangles ##stop"
        scene.cache_write( cache_name,tris)
      else
        puts "CACHE HIT for gamma=#{gamma}"
      end
      
      puts "Adding points and triangles to model ##start"
      m2 = surf_model

      debug = false
      if debug
        @armodel ||= add_model("arrows debug")
        @armodel.reset(true)
        tris.each{ |t|
          r = 0.1
          @armodel.add_arrow( vertices_for_tri[ t.p2 ].to_point, vertices_for_tri[ t.p1 ].to_point,r )
          @armodel.add_arrow( vertices_for_tri[ t.p1 ].to_point, vertices_for_tri[ t.p3 ].to_point,r )
          @armodel.add_arrow( vertices_for_tri[ t.p3 ].to_point, vertices_for_tri[ t.p2 ].to_point,r )
        }
        @armodel.refresh
      end

      begin
        t0 = m2.mesh.positions.count
        vertices_for_tri.each{ |v| m2.add_node( v.X, v.Y, v.Z ) }
        #tris.each{ |t| m2.add_triangle( t0+t.p2, t0+t.p1, t0+t.p3 ) }
        tris.each{ |t| m2.add_triangle_trusted( t0+t.p2, t0+t.p1, t0+t.p3 ) }
      end


      puts "Points and triangles added ##stop"
    end

    [ball_model,lines_model,surf_model].each{ |m| m.refresh }

    puts "Gamma=#{gamma} | #{indices.length} points ##title"
    gamma
  end

  def show_gamma_many
    gg = []
    @sliders.each_with_index do |sl,i|
      gg << show_gamma( sl.value.to_i, true, i )
    end
    puts "Gammas: #{gg.compact.sort} ##title"
  end

end

#end