class Setki9MikeLoader < Loader

  # require 'WindowsBase'
  # include System::Windows

  #   feel(p) is invoked to determine - can this file load data or not?
  #
  #   p.ext // file extension in lower case, e.g. "dat"
  #   p.first_2k // first 2048 bytes of file data.
  #   p.firstlines // ascii presentation of first2k. If file contains \0, firstlines is cutted to that first \0.
  #   p.name // file name without extension
  #   p.path // full file path
  def self.feel(p)
  #  puts "Invoked feel, path #{p.path}, first lines #{p.first_lines}"
    p.first_lines =~ /TITLE.+VARIABLES.+ZONE/mi ? 2.85 : 0.0
  end

  #   load(p) is invoked to load data, if this script is winner of feelings
  def load(p)
    puts "We are loading..."
    counter = zcounter = 0
    file = File.new( p.path , "r")
    group = scene.add_group( p.name )
    tmin = 100000000
    tmax = -100000000
    zone_data = nil
    di,dj,dk = 0,0,0
    show_body = false
    show_points = false
    show_level_3 = false

    while (line = file.gets)
      items = line.strip.split(/\s+/) [0..3]
      next if items.length == 0
      vals = items.map{ |i| i.to_f*10 }

      if items[0] =~ /ZONE/ #and zcounter == 0
        m = add_model(p.name+"\\block #{zcounter=zcounter+1} ", line.strip, true, group )
        ## scene.set_model_group(m,group)
        m.color_str = ["red","green","blue","#00cccc","#aa33cc","#1f7"][zcounter % 6]
        # ZONE I=   26, J=   18, K=    9, F=POINT
        # ZONE I=          31 ,J=          31 ,K=          15 ,F=POINT

        line =~ /ZONE\s*I=\s*(\d+)\s*,\s*J=\s*(\d+)\s*,\s*K=\s*(\d+)\s*,\s*F=POINT/
        # di, dj, dk = $1.to_i, $2.to_i, $3.to_i
        dk, dj, di = $1.to_i, $2.to_i, $3.to_i
        zone_data = Array.new(di) {Array.new(dj) { Array.new(dk) {0} }}
        puts "got new zone di,dj,dk=#{di},#{dj},#{dk}"
      else
        next
      end

      puts "loading points di,dj,dk=#{di},#{dj},#{dk}"
      for i in (0...di)
        for j in (0...dj)
          for k in (0...dk)
            line = file.gets
            items = line.strip.split(/\s+/)[0..3]
            next if items.length < 3 #skip blank lines
            vals = items.map{ |i| i.to_f*10 }
            zone_data[i][j][k] = vals
          end
  # puts "#{i} #{j} #{k} #{zone_data[i][j].inspect}"

        end
      end

      puts "adding lines"
      for i in (0...di)
        for j in (0...dj)
          next if (not show_body) and not ( [0,di-1].include?(i) or [0,dj-1].include?(j) )
          # risuem
          slice = zone_data[i][j]
          for k in (0...(dk-1))
          #void AddLine(Point3D p1, Point3D p2, double thickness = 0.01, int meridians = 8);
            pt  = Point3D.new( slice[k][0],  slice[k][1],   slice[k][2] )
            pt2 = Point3D.new( slice[k+1][0],slice[k+1][1], slice[k+1][2] )
  #          m.color_value = k/dk
            m.add_line pt, pt2
            m.add_sphere( slice[k][0],  slice[k][1],   slice[k][2], 0.05, 3, 2 ) if show_points
          end
          #m.add_sphere( vals[0], vals[1], vals[2], 0.05, 3, 2 )
        end
      end

  ### 2ND
      for i in (0...di)
        for k in (0...dk)
          next if (not show_body) and not ( [0,di-1].include?(i) or [0,dk-1].include?(k) )
          # risuem
          for j in (0...(dj-1))
          #void AddLine(Point3D p1, Point3D p2, double thickness = 0.01, int meridians = 8);
            q = zone_data[i][j][k]
            pt  = Point3D.new( q[0],  q[1], q[2] )
            q = zone_data[i][j+1][k]
            pt2 = Point3D.new( q[0],  q[1], q[2] )
  #          m.color_value = k/dk
            m.add_line pt, pt2
  #          m.add_sphere( slice[k][0],  slice[k][1],   slice[k][2], 0.05, 3, 2 )
          end
          #m.add_sphere( vals[0], vals[1], vals[2], 0.05, 3, 2 )
        end
      end

  ### 3ND
  if show_level_3
      for k in (0...dk)
        for j in (0...dj)
          next if (not show_body) and not ( [0,dj-1].include?(j) or [0,dk-1].include?(k) )
          # risuem
          for i in (0...(di-1))
          #void AddLine(Point3D p1, Point3D p2, double thickness = 0.01, int meridians = 8);
            q = zone_data[i][j][k]
            pt  = Point3D.new( q[0],  q[1], q[2] )
            q = zone_data[i+1][j][k]
            pt2 = Point3D.new( q[0],  q[1], q[2] )
  #          m.color_value = k/dk
            m.add_line pt, pt2
  #          m.add_sphere( slice[k][0],  slice[k][1],   slice[k][2], 0.05, 3, 2 )
          end
          #m.add_sphere( vals[0], vals[1], vals[2], 0.05, 3, 2 )
        end
      end
  end

    end
    file.close

    created_models.each{ |mm|
    mm.set_color_table( 0.33 => "blue", 0.65 => "green", 1 => "red" );
  #    mm.set_color_table( 0 => "blue", 0.5 => "green", 1 => "red" );
  #    mm.set_color_table( 0 => "black", 0.3 => "green", 1 => "red" );
  #####  mm.set_color_range(tmin,tmax)
  #    mm.set_color_range(8,15)
    mm.set_color_range(0,1)
    }

    puts "#{counter} points, #{zcounter} zones, tmin = #{tmin}, tmax = #{tmax}"
  end

end