# Example of loader class.

class CrystalLoader < Loader

  #   feel(p) is invoked to determine - can this file load data or not?
  #
  #   p.name // file name without extension
  #   p.ext // file extension in lower case, e.g. "dat"
  #   p.name_ext // file name with ext, e.g. "file.dat"
  #   p.first_2k // first 2048 bytes of file data.
  #   p.first_lines // ascii presentation of first2k. If file contains \0, firstlines is cutted to that first \0.
  #   p.path // full file path
  def self.feel(p)
    p.first_lines =~ /Cristal (\d+)x(\d+)x(\d+)/mi ? 1.0 : 0.0
  end

  #   load(p) is invoked to load data, if this script is winner of feelings
  def load(p)
    file = File.new( p.path , "r")

    mo = add_model( "o " )# + p.name_ext )
    mo.color_str = "blue"
    mo.back_color_str = ""
    mt = add_model( "t " )# + p.name_ext )
    mt.color_str = "brown"
    mt.back_color_str = ""
    puts "#{p.path} ##title"

    rt = ro = 0.2

    t = 0
    rx,ry,rz = 0,0,0
    while line = file.gets
      if line =~ /Cristal (\d+)x(\d+)x(\d+)/i 
        rx,ry,rz = $1.to_i,$2.to_i,$3.to_i
        break
      end
    end

    return if rx == 0
    co=0
    ct=0
    for z in (0...rz) do
      puts "z=#{z}, oc=#{co}, tc=#{ct}"
      for y in (0...ry) do
        line = file.gets
        #puts line
        line =~ /\s*\d+: ([a-z]+)$/i
        #puts $1
        dat = $1[0..rx]

        for x in (0...rx) do
          c = dat[x]
          px,py,pz = x-rx/2.0, y-ry/2.0, z-rz/2.0
          #px,py,pz = x,y,z
          if c == 'o'
            mo.add_sphere px,py,pz,ro,3,2
            co=co+1
          elsif c == 't'
            mt.add_sphere px,py,pz,rt,3,2
            ct=ct+1
          end
        end

      end
      file.gets
    end

    file.close
  end

end