require 'Triangulator'
#include Visualizator::Triangulator
include System::Collections::Generic
require 'Contracts'

#require 'System'
load_assembly 'System.Core' #timespan
load_assembly 'PresentationFramework' # for controls
load_assembly 'WindowsBase' #dispatchertimer

#include System::Windows
include System::Windows::Controls
include System::Windows::Controls::Primitives # needed for control constatns...
# include System::Windows::Threading


class TimofeyAnimatedGraphLoader < Loader


  # require 'WindowsBase'
  # include System::Windows

  #   feel(p) is invoked to determine - can this file load data or not?
  #
  #   p.ext // file extension in lower case, e.g. "dat"
  #   p.first_2k // first 2048 bytes of file data.
  #   p.first_lines // ascii presentation of first2k. If file contains \0, firstlines is cutted to that first \0.
  #   p.name // file name without extension
  #   p.path // full file path
  #   p.dir  // file dir, e.g. d:\data\sample5\

  def self.feel(p)
    return 0 if p.ext != "txt"
    lines = p.first_lines.split(/\r/)
    float="[-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?"
    float3="^\s*#{float}\s+#{float}\s+#{float}\s*$"
    lines[0] =~ /^\s*\d+\s+\d+\s*$/ and lines[1] =~ /#{float3}/ and lines[2] =~ /#{float3}/ and lines[3] =~ /#{float3}/  ? 0.99 : 0.0
  end

  #   load(p) is invoked to load data, if this script is winner of feelings
  def load(p)
    first_load = @model.nil?
    puts "Loading #{p.name}. First load = #{first_load}"

    if first_load and p.name =~ /^(.+)_(\d+)$/
      puts "Name is multifile, looking all file names 0..1000"
      @multifile = true
      @basename = $1
      @current_value = $2.to_i
      @modelname = @base
      @min = 10000
      @max = -1
      @basedir = p.dir

      c = 0
      for i in (0..1000) do
        name = "#{@basedir}#{@basename}_#{i}.txt"
        puts "looking #{name}"
        if File.exist?( name )
          @min = i if @min > i
          @max = i if @max < i
        else
          break if @max > 0
        end
      end

      puts "Found min=#{@min}, max=#{@max}"
    end

    if first_load
      n = "#{p.dir_name} - #{@basename || p.name} CURRENT"
      @model = add_model( n )
      scene.make_selected_model( n )
    else
      puts "Resetting model"
      @model.reset
      # @model.title = "#{p.dir_name} - #{p.name}"
    end

    load_file_to_model(p.path, @model)

    if first_load and @multifile
    slider = System::Windows::Controls::Slider.new
  #  slider.content = "File number"
    slider.minimum = @min
    slider.maximum = @max
    slider.value = @current_value
    slider.IsSnapToTickEnabled = true
    slider.TickFrequency = 1
    slider.TickPlacement = TickPlacement.Both
    slider.AutoToolTipPlacement = AutoToolTipPlacement.BottomRight

  #  bind = Binding.new("file_num")
  #  bind.source = proxy_filter
  #  slider.SetBinding(RangeBase.ValueProperty, bind);

     @timer = System::Windows::Threading::DispatcherTimer.new
     @timer.interval = System::TimeSpan.new(0,0,0,0,50);
     @timer.tick { @timer.stop; load( Contracts::FileProbe.new( "#{@basedir}#{@basename}_#{@current_value}.txt" ) ) }

    slider.value_changed do |sender, args|
       @current_value = slider.value.to_i
  #     puts "value changed: #{@current_value}" # HINT: if we write here, slider begins to jump
       @timer.stop
       @timer.start
  ##     load( Contracts::FileProbe.new( "#{@basedir}#{@basename}_#{@current_value}.txt" ) )
  #    file.seek( sender.hit_value, IO::SEEK_SET)
  #    puts "File #{p.name} offset #{sender.hit_value+1}: #{file.gets}"
  #    puts "Hello there, sender is #{sender.inspect}, args are #{args.inspect}"
    end

    @model.add_ui_element(slider,"Current file")


    load_all_btn = System::Windows::Controls::Button.new
    load_all_btn.content = "Show all files"
    puts "Показать все файлы"

    load_all_btn.click do
      group = scene.add_group( "#{p.dir_name} - #{@basename} files" )
      for i in (@min..@max) do
        m = add_model( "#{@basename}_#{i}.txt","",true,group )
        name = "#{@basedir}#{@basename}_#{i}.txt"
        load_file_to_model(name, m, 0.07)
        m.refresh
      end
    end

    @model.add_ui_element(load_all_btn)


    end

  #            var current_t = new Slider { Minimum = 0, Maximum = loaded_data.slices.Count-1 };
  #            //current_t.ValueChanged
  #            var bind = new Binding("CurrentT") { Source = this };
  #            current_t.SetBinding(RangeBase.ValueProperty, bind);
  #            model.AddUIElement(current_t);

  #                var reload = new System.Windows.Controls.Button { Content = "blabla" };
  #                reload.Tag = p.Path;
  #                reload.Click += new System.Windows.RoutedEventHandler(reload_Click);
  #                //current_t.ValueChanged

  #  @model.add_property( "FileN",self );

  ### -> this is working sample  @model.add_property( "Contracts.Range,Contracts", "file_n", loader_proxy )

  #  @model.set_control("FileN", scene.get_control_factory_by_type(Contracts::Range).first.new_control, "File Number");
  # also: Factory.method(:create_service).of(System::String).call(serviceName)

    @model.hit_tested do |sender, args|
  #    file.seek( sender.hit_value, IO::SEEK_SET)
  #    puts "File #{p.name} offset #{sender.hit_value+1}: #{file.gets}"
  #    puts "Hello there, sender is #{sender.inspect}, args are #{args.inspect}"
    end

    @model.refresh

    puts "Well done #{p.name}"
  end

  #def onhit
  #end

  # executed on system start
  def start
    puts "executed start of #{__FILE__}"
  end

  @filenum = 0
  def file_n=(value)
    puts "Invoked file_n=, value=#{value.inspect}, val=#{value.value}"
    @filenum = value.value.to_i
  end

  def file_n
    puts "Invoked file_n"
    [@filenum,0,5]
  end

  def load_file_to_model(path,m,r=0.10)
    puts "loading #{path}"
    file = File.new( path , "r")
    d,n = file.gets.split.map{ |d| d.to_i }

    i = 0
    while (i < n) and (line = file.gets) do
      i = i+1
      items = line.strip.split(/\s+/) [0..2]
      next if items.length == 0
      x,y,z = items.map{ |i| i.to_f }
      m.add_sphere( x, y, z, r, 3, 2 )
    end

    file.close
  end

end